
with(share): readshare(algcurve,geometry): # read `algcurve.m`;
with(algcurve):

if type( x0*x1^2 + a*x1*x2^2 + b*x1^3, projpoly) = true  and
   type ( a*x*y + y^2, projpoly([x,y],3) ) = false 
then print(`projpoly okay`) 
else print(`Error in projpoly`) fi;

if type([0,0,0,0], projcoord) = false  and
   type([ 0, 1, 0], projcoord(2)) = true 
then print(`projcoord okay`) 
else print(`Error in projcoord`) fi;

if hompoly( y^2 + x^3 - x^2 ,[x,y], [u,v,w], 2 ) = w*v**2+u**3-w*u**2    and
   hompoly(a*x + b*y + 1) = a*x1+b*x2+x0 
then print(`hompoly okay`) 
else print(`Error in hompoly`) fi;

if affpoly( w*v**2+u**3-w*u**2, [u,v,w], [x,y], 2 ) = y**2+x**3-x**2   and
   affpoly(a*x1+b*x2+x0) = a*x+b*y+1
then print(`affpoly okay`) 
else print(`Error in affpoly`) fi;

if hompoint( [a,b], 1 ) = [a, 1, b]  and
   hompoint( [a,b] , 2 ) = [a, b, 1] 
then print(`hompoint okay`) 
else print(`Error in hompoint`) fi;

if affpoint( [ 3, 1+I, 6/5 ] ) = [1/3+1/3*I, 2/5]  and
   affpoint( [ a, b, c ],2) = [1/c*a, 1/c*b] 
then print(`affpoint okay`) 
else print(`Error in affpoint`) fi;

if poly2coord( a*x0 + c*x2 + b*x1 ) = [a, b, c]  and
   poly2coord ( v^3 + u*v^2 - u*w^2 , [u,v,w] ) =
               [0, 0, 0, 1, 0, -1, 1, 0, 0, 0] 
then print(`poly2coord okay`) 
else print(`Error in poly2coord`) fi;

if  coord2poly([0, 0, 0, 1, 0, -1, 1, 0, 0, 0]) = x0*x1**2-x0*x2**2+x1**3  and
    coord2poly([a, b, c]) = coord2poly([a, b, c])
then print(`coord2poly okay`) 
else print(`Error in coord2poly`) fi;

if  standard( [ 0, 1 - x + I - I*x, 1 + I ] ) = [0, -1+x, -1]  and
    standard ( -a^2*x1 + a*(1-a)*x2 ) = a*x1+(-1+a)*x2 
then print(`standard okay`) 
else print(`Error in standard`) fi;

if homequal( [1,2,3], [2,4,6]) = true and
   homequal( [3,4,6,8], [3*I, 4*I, 6*I, 8*I] ) = true
then print(`homequal okay`) 
else print(`Error in homequal`) fi;




if homtrans([ a*x + b*y + c, d*x + e*y + f ]) = 
   [x0, a*x1+b*x2+x0*c, d*x1+e*x2+x0*f]  and
   homtrans ( [ y^2 + x^3 - x^2, x^3 - y^2 ] )  =
   [x0, x0*x2**2+x1**3-x0*x1**2, x1**3-x0*x2**2]
then print(`homtrans okay`) 
else print(`Error in homtrans`) fi;

if afftrans ([x0, a*x1+b*x2+x0*c, d*x1+e*x2+x0*f]) = [a*x+b*y+c, d*x+e*y+f] and
   afftrans ([x0, x0*x2**2+x1**3-x0*x1**2, x1**3-x0*x2**2])  =
   [y**2+x**3-x**2, x**3-y**2]
then print(`afftrans okay`) 
else print(`Error in afftrans`) fi;

if linalg[equal](image2mat ([x0, a*x1+b*x2+x0*c, d*x1+e*x2+x0*f]) ,
                 linalg[matrix]([[1, 0, 0], [c, a, b], [f, d, e]]) ) and
   linalg[equal](image2mat ([a*x0+b*x1,c*x1+d*x2,e*x0+f*x1]) , 
                 linalg[matrix]([[a, b, 0], [0, c, d], [e, f, 0]]) )
then print(`image2mat okay`) 
else print(`Error in image2mat`) fi;

if mat2image (linalg[matrix]([[a, b, 0], [0, c, d], [e, f, 0]])) =
   [a*x0+b*x1, c*x1+d*x2, e*x0+f*x1]  and
   mat2image (linalg[matrix]([[1, 0, 0], [c, a, b], [f, d, e]]))  =
   [x0, a*x1+b*x2+x0*c, d*x1+e*x2+x0*f]
then print(`mat2image okay`) 
else print(`Error in mat2image`) fi;

if NonCurvePt( y^2 + x^3 - x^2 ) = [1, 1] and
   NonCurvePt( hompoly(y**2+x**3-x**2),1, [[0,1,0],[1,1,1]], [x0,x1,x2] )  =
   [0, 1, 1]
then print(`NonCurvePt okay`) 
else print(`Error in NonCurvePt`) fi;

if linalg[equal]( NonVertexTrans(x0*x2^2 + x0*x1^2 + x1^3),
                  linalg[matrix]([[1, 0, 1], [1, 1, 0], [0, 0, 1]]) )  and
   linalg[equal]( NonVertexTrans(x0*x2^2 + x0*x1^2 + x1^3, [[1,4,5]], 
                                 [x0,x1,x2] ),
                  linalg[matrix]([[1, 0, 1], [4, 1, 0], [5, 0, 1]]))
then print(`NonVertexTrans okay`) 
else print(`Error in NonVertexTrans`) fi;


if linalg[equal]( PtTrans([ [1,2,3], [0,1,4], [2,2,1] ],
                          [ [1,1,2], [-1,0,1], [1,0,-2] ]) ,
                  linalg[matrix]([[-2, 7, -2], [-4, 12, -3], [-9, 22, -5]]) )
then print(`PtTrans okay`) 
else print(`Error in PtTrans`) fi;




if multcomp((x0-x1)^2 * (2*x1*x0 + x2^2)) = true  and
   multcomp(x*y) = false
then print(`multcomp okay`) 
else print(`Error in multcomp`) fi;

if commoncomp((x0-x1)^2 * (2*x1*x0 + x2^2),(x0 - x1)*(x0 + x2)) = true  and
   commoncomp((x0-x1)^2 * (2*x1*x0 + x2^2),(x0 - x1)*(x0 + x2),[x2]) = false
then print(`commoncomp okay`) 
else print(`Error in commoncomp`) fi;

if appoly (x^6 - x^2*y^3 - y^5, [ [-2,2], [-3,3], [2,4] ] ) = 
          [0, 243, -1216] and
   appoly ( x0 - 3*x1 + 5*x2, [0,a,b] )  = -3*a+5*b
then print(`appoly okay`) 
else print(`Error in appoly`) fi;

if appimage ([x0, x1+a*x0, x2+x0*b],x0*x2**2+x1**3-x0*x1**2) = 
   x0*(x2+x0*b)**2+(x1+a*x0)**3-x0*(x1+a*x0)**2  and
   appimage ([ x + a , y + b ],y^2 + x^3 - x^2)  = (y+b)**2+(x+a)**3-(x+a)**2
then print(`appimage okay`) 
else print(`Error in appimage`) fi;

if appmat ( linalg[matrix] ([ [1,0,0], [c,a,b], [f,d,e] ]),
            y^3 - x*z^2, [x,y,z] ) =
   (c*x+a*y+b*z)**3-x*(f*x+d*y+e*z)**2  and
   appmat ( linalg[matrix] ([ [1,0,0], [c,a,b], [f,d,e] ]),x1 )  = 
   a*x1+b*x2+x0*c
then print(`appmat okay`) 
else print(`Error in appmat`) fi;



if grad( y^2 + x^3 - x^2 ) = [3*x**2-2*x, 2*y]  and
   grad( hompoly( y^2 + x^3 - x^2 ) )  = 
   [x2**2-x1**2, 3*x1**2-2*x1*x0, 2*x2*x0]
then print(`grad okay`) 
else print(`Error in grad`) fi;

if convert( singularities ( 2*x^4 - 3*x^2*y + y^2 - 2*y^3 + y^4 ), set ) =  
   {[0, 0], [0, 1]}  and
   convert( singularities ( x^2 + c*y^2*x - b*x ), set )  = 
   {[0, -(c*b)^(1/2)/c], [0, (c*b)^(1/2)/c]}
then print(`singularities okay`) 
else print(`Error in singularities`) fi;

if issingular(x^3 - y^2,[0,0]) = true  and
   issingular ( x0*x2^2 + x1^3 - x0*x1^2,[1,-3, 6] )  = false
then print(`issingular okay`) 
else print(`Error in issingular`) fi;

if isregular(x^3 - y^2,[0,0]) = false   and
   isregular ( x0*x2^2 + x1^3 - x0*x1^2,[1,0,0])  = false
then print(`isregular okay`) 
else print(`Error in isregular`) fi;

if isordinary(x^3 - y^2,[0,0]) = false
then print(`isordinary okay`) 
else print(`Error in isordinary`) fi;

if curvetaylor (x^2 + y^2 - 1, [0,-1] ) = -2*y-2+x**2+(y+1)**2 and
   curvetaylor ( x1^3 - x0*x2^2, [1,0,0] ) = -x2**2+x1**3-(x0-1)*x2**2
then print(`curvetaylor okay`) 
else print(`Error in curvetaylor`) fi;

if multiplicity( x^2 + y^2 - 1 , [0,1] ) = 1  and
   multiplicity( x^2 + y^2 - 1 , [1,1] ) = 0
then print(`multiplicity okay`) 
else print(`Error in multiplicity`) fi;

if tangent ( x^2 + y^2 - 1, [ a,b ] ) = 2*(x-a)*a+2*(y-b)*b and
   tangent (2*x1^4  - 3*x0*x1^2*x2 + x0^2*x2^2  - 2*x0*x2^3  + x2^4, 
            [ 1, 0, 1] )  =  [x1*3**(1/2)-x2+x0, -x1*3**(1/2)-x2+x0]
then print(`tangent okay`) 
else print(`Error in tangent`) fi;

if convert(RegCurvePts ( y^2 + x^3 - x^2, 3 ),set) = 
   { [1, 0], [-3, -6], [-3, 6] } and
   convert(RegCurvePts ( x0*x2**2+x1**3-x0*x1**2, 3 ),set)  = 
   {[1, 1, 0], [1, -3, 6], [1, -3, -6]}
then print(`RegCurvePts okay`) 
else print(`Error in RegCurvePts`) fi;


if Polar ( x0*x2 - x1^2, [ 1, 0, -1 ] ) = x0-x2   and
   Polar ( x^2 + y^2 - 1, [ 1, 1 ] )  = 1-x-y
then print(`Polar okay`) 
else print(`Error in Polar`) fi;

if convert(tangentthrupt ( x^2 + y^2 - 1, [ 1, 1 ] ),set) = {y-1, x-1} and
   convert(tangentthrupt ( x0*x2^2 + x1^3 - x0*x1^2 , [ 0, 1, 0 ] ),set)  =
   {x0, 2*x0-3*3**(1/2)*x2, 2*x0+3*3**(1/2)*x2}
then print(`tangentthrupt okay`) 
else print(`Error in tangentthrupt`) fi;



if convert(linearsystem ( [ [ 1, 4, 5 ] ], 1 ),set) = 
   { -4*x0+x1, -5*x0+x2 } and
   convert(linearsystem ( [ [ [ 1,1,1 ],2]],2),set) =
   {x0**2-x0*x1-x0*x2+x1*x2, x0**2-2*x0*x2+x2**2, x0**2-2*x0*x1+x1**2}
then print(`linearsystem okay`) 
else print(`Error in linearsystem`) fi;

if convert(intersection( x^2 + y^2 - 1, x - y ),set) =
   {[-1/2*2**(1/2), -1/2*2**(1/2)], [1/2*2**(1/2), 1/2*2**(1/2)]}  and
   convert(intersection ( x0*x2^2 + x1^3 - x0*x1^2,x1^3 - x0*x2^2),set)  =
   {[4, 2, -2**(1/2)], [4, 2, 2**(1/2)], [0, 0, 1], [1, 0, 0]}
then print(`intersection okay`) 
else print(`Error in intersection`) fi;

if intermultiplicity( x^2 + y^2 - 1, y - 1, [ 0, 1 ] ) = 2 and
   intermultiplicity(x0*x2**2+x1**3-x0*x1**2,x0*x2**2+x0*x1**2+x1**3,[1,0,0])
   = 4 
then print(`intermultiplicity okay`) 
else print(`Error in intermultiplicity`) fi;

if Hessian ( y^2 + x^3 - x^2 ) = x**2-y**2+3*x*y**2  and
   Hessian ( x0*x2^2 + x1^3 - x0*x1^2 )  = x0*x1**2-x0*x2**2+3*x2**2*x1
then print(`Hessian okay`) 
else print(`Error in Hessian`); fi;

if inflections ( x1**3-x0*x2**2 ) = [[0, 0, 1]] and
   convert(inflections ( x0*x2^2 + x0*x1^2 + x1^3 ),set)  = 
   {[0, 0, 1], [9, -12, -4*3**(1/2)], [9, -12, 4*3**(1/2)]}
then print(`inflections okay`) 
else print(`Error in inflections`) fi;

if convert(tryall(intersection( x^2 + y^2 - 1, y - x^2 )),set) =  
{[1/2*(-2+2*5^(1/2))^(1/2), -1/2+1/2*5^(1/2)],
[1/2*(-2+2*5^(1/2))^(1/2),-1/2-1/2*5^(1/2)],
[-1/2*(-2+2*5^(1/2))^(1/2), -1/2+1/2*5^(1/2)],
[-1/2*(-2+2*5^(1/2))^(1/2), -1/2-1/2*5^(1/2)],
[1/2*(-2-2*5^(1/2))^(1/2), -1/2+1/2*5^(1/2)],
[1/2*(-2-2*5^(1/2))^(1/2), -1/2-1/2*5^(1/2)],
[-1/2*(-2-2*5^(1/2))^(1/2), -1/2+1/2*5^(1/2)],
[-1/2*(-2-2*5^(1/2))^(1/2), -1/2-1/2*5^(1/2)]}
then print(`tryall okay`) 
else print(`Error in tryall`) fi;



if explicit ( x**3-x**2+y**2, 'inv' ) = [1-t**2, -t**3+t] and
   explicit (x1**6-x0*x1**2*x2**3-x0*x2**5)  = 
   [1, t**3*(t**2+1), t**4*(t**2+1)]
then print(`explicit okay`) 
else print(`Error in explicit`) fi;

if implicit ( [ 1-t^2 , t*(1-t^2) ] ) = x**3-x**2+y**2 and
   implicit ( [ m^2 , m ], m, [ u, v ] )  = -v**2+u
then print(`implicit okay`) 
else print(`Error in implicit`) fi;

if quadtrans(x0+x1+x2) = x1*x2+x0*x2+x0*x1  and
   quadtrans( y^2 + x^3 - x^2 )  = y**2-x*y**2+x**3
then print(`quadtrans okay`) 
else print(`Error in quadtrans`) fi;

#quit
