############################################################################
#
#	              The test file for the TeX package
#  	      _________________________________________________
#
#   This was tested under Maple 4.2 & 5.0, TeX 3.0, AmS-TeX 2.0, LaTeX 2.09.
#
# How to use this file:
# ====================
#
#	1). 	cd to the directory which contains the 2 .m files tex.m and
#		TeX.m you have installed.
#	2).	Invoke maple as usual. For people who are still using maple
#		version 4.2, better use the quiet "-q" option.
#	3).	Read this file into maple. It may take several minutes 
#		for maple to work through this file.
#	4).	In step 3) maple generates 3 .tex files: ams.tex, la.tex 
#		and pln.tex. Run tex on ams.tex and pln.tex; run latex on
#		la.tex.
#	5).	Browse through the 3 .tex files to see if there are any
#		error messages.
#	6).	Finally, print out the 3 .dvi files to check the results
#		(or use dvipage).
#
#########################################################################

#read `tex.m`;
with(share):readshare(tex,system):
t[4,5]:=f:
tt[2,1]:=g:
tt[2,2]:=t:
x:=f(y):
tmp:=[
exp(x^2-y),
f3((a-b)*(b-c)),
G(a^2-2*b^3),
f(x^2/3-1),
G(x^2-1)^3*a*H,
taylor(sin(y),y=0),
d=2,
a[2,3][4,5],
a[b3,c4[5]],
7..4,
457658976.456874585476854,
.000000065843768546,
a**(1/4),
(4*x**5-77*x**4+40*x**3+21*x**2+55*x+61)/(16*x**2-44*x**3-70*x**4-23*x**4*y-67*
x**3*y**2-97*x**2*y**3+10),
-278*sin(d)**2*m+1818*sin(d)*m*a**(1/2)-2448*m-84*m**3*a-84*sin(d)*a**(3/2)
-474*m**2+507*sin(d)*m**2-388800+78*sin(d)**2*m*a**(1/2)-492*a**2+234*m**4-22*m
**5-19224*sin(d)*a**(1/2)+2664*sin(d)**2*a**(1/2)+77*sin(d)**4*m+120*sin(d)**4-
26*sin(d)**5-72*a**(3/2)-32*sin(d)*m**3+19236*sin(d)**2,
(a*(f-e)-b*(e*f))*x*y-x*y^2-x^3-1,
expand((x2*(x3-y3-5*z3)-y2-1)*x1-a*x1*y1-a*z1*z3-1),
a*b*c*d*(e-f^2)*x*y*z,
a*b*c*d*(e-f^2)^3*x*y*z,
[a,b,c,d],
{a^3*b-c,d,34,55,e,f},
[$1..50],
['2*x*y^2-x-y-1'$10],
[],
{},
2*a^2*b5^3-2/3*v1^3+a*b*c,
&^(w1,w2,w3),
a^beta*b,
-x*(y-x),
-3*a^4*b*c[5]*(d-e)*f*(a-b)*h,
f(x)*a,
4/3*a*b^3*c*d5*(e-f)*(g-h^4)*k*(m-n)^r*p,
(-5*a^3*b*(4*c-d*(e-f)))-sin(x)^5-9*(m[p,q]-n[5])^6+15+(-1)^g,
expand((2*x/3-y/z/7+5*z)^3),
3/5*x^3*y*(a-b)*(b-d)^4*z,
(a*(f-e)-b*(e*f))*x*y-x*y^2-x^3-1,
(a*(f-e)-b*(e*f))*x*y-x*y^2-x^3-1,
(x2*(x3-y3-5*z3)-y2-1)*x1-a*x1*y1-a*z1*z3-1,
((x2*(x3-y3-5*z3)-y2-1)*x1-a*x1*y1-a*z1*z3-1 )^2,
(b-a-c)^3,
2*a*b*(b-a/c)^3*x*y-1,
x-(b-a)*y-a*z-1,
1/(20*b),
d(f)<=-expand((x+y)^10),
a*t,
v=t^2,
tt
]:
texvar:=[x1,y1,z1,plex],[x2,y2,z2,plex],[x3,y3,z3,plex],[x,y,z],
	[a,b,b5,c,d,d5,e,f,g,h,G],[sin(d),f(s),m,beta]:
tex_caller:=amstex:
test_(ams);
for i in tmp do lprint(``);mtex(i);lprint(``);stex(i);od:
exit;
tex_caller:=latex:
test_(la);
for i in tmp do lprint(``);mtex(i);lprint(``);stex(i);od:
exit;
tex_caller:=plain:
test_(pln);
for i in tmp do lprint(``);mtex(i);lprint(``);stex(i);od:
#quit;
